on prepareMovie
  global ballList, paddleSprite
  set ballList to []
  set paddleSprite to 4
  puppetSprite(paddleSprite, 1)
  puppetSprite(6, 1)
  repeat with currentChannel = 10 to 19
    puppetSprite(currentChannel, 1)
    set the stretch of sprite currentChannel to 1
  end repeat
end

on DoButton
  if (the mouseCast = the number of member "New Color Art") or (the mouseCast = the number of member "New Color Text") then
    createBall(1)
  else
    if (the mouseCast = the number of member "New BW Art") or (the mouseCast = the number of member "New BW Text") then
      createBall(0)
    else
      placePaddle()
    end if
  end if
end

on placePaddle
  global paddleSprite
  set the locH of sprite paddleSprite to the mouseH
  set the locV of sprite paddleSprite to the mouseV
  set the locH of sprite 6 to the locH of sprite paddleSprite - (0.5 * the width of sprite 6)
  set the locV of sprite 6 to the locV of sprite paddleSprite - ((0.80000000000000004 * the height of sprite 6) + (0.25 * the height of sprite paddleSprite))
end

on createBall whichType
  global ball1, ballList
  if count(ballList) >= 10 then
    beep()
  else
    if whichType = 1 then
      add(ballList, new(script "Color Parent", count(ballList) + 1))
    else
      add(ballList, new(script "BW Parent", count(ballList) + 1))
    end if
  end if
end

on DoAnimation
  global ball1, ballList
  if count(ballList) > 0 then
    repeat with t = 1 to count(ballList)
      animateBall(getAt(ballList, t))
    end repeat
  end if
end
